Index: NEMO/branches/2020/dev_r12558_HPC-08_epico_Extra_Halo/src/ABL/ablmod.F90
===================================================================
--- NEMO/branches/2020/dev_r12558_HPC-08_epico_Extra_Halo/src/ABL/ablmod.F90	(revision 13228)
+++ NEMO/branches/2020/dev_r12558_HPC-08_epico_Extra_Halo/src/ABL/ablmod.F90	(revision 13229)
@@ -732,12 +808,12 @@
             END DO
          END DO
-            
-         DO jk = jpkam1,1,-1            
+
+         DO jk = jpkam1,1,-1
             DO ji = 1,jpi
                tke_abl(ji,jj,jk,nt_a) = tke_abl(ji,jj,jk,nt_a) + zCF(ji,jk) * tke_abl(ji,jj,jk+1,nt_a)
             END DO
          END DO
-         
-!!FL should not be needed because of Patankar procedure  
+
+!!FL should not be needed because of Patankar procedure
          tke_abl(2:jpi,jj,1:jpka,nt_a) = MAX( tke_abl(2:jpi,jj,1:jpka,nt_a), tke_min )
 
@@ -745,15 +821,15 @@
          !! Diagnose PBL height
          !! ----------------------------------------------------------
-         
-         
-         !                                                       
+
+
+         !
          ! arrays zRH, zFC and zCF are available at this point
          ! and zFC(:, 1 ) = 0.
          ! diagnose PBL height based on zsh2 and zbn2
          zFC (  :  ,1) = 0._wp
-         ikbl( 1:jpi ) = 0 
-         
+         ikbl( 1:jpi ) = 0
+
          DO jk = 2,jpka
-            DO ji = 1, jpi 
+            DO ji = 1, jpi
                zcff  = ghw_abl( jk-1 )
                zcff1 = zcff / ( zcff + rn_epssfc * pblh ( ji, jj ) )
@@ -781,15 +857,15 @@
             ELSE
                pblh( ji, jj ) = ghw_abl(jpka)
-            END IF 
-         END DO
-      !-------------      
-      END DO      
-      !-------------
-      !
-      ! Optional : could add pblh smoothing if pblh is noisy horizontally ... 
+            END IF
+         END DO
+      !-------------
+      END DO
+      !-------------
+      !
+      ! Optional : could add pblh smoothing if pblh is noisy horizontally ...
       IF(ln_smth_pblh) THEN
-         CALL lbc_lnk( 'ablmod', pblh, 'T', 1.)
+         CALL lbc_lnk( 'ablmod', pblh, 'T', 1.) !, kfillmode = jpfillnothing)
          CALL smooth_pblh( pblh, msk_abl )
-         CALL lbc_lnk( 'ablmod', pblh, 'T', 1.)	  
+         CALL lbc_lnk( 'ablmod', pblh, 'T', 1.) !, kfillmode = jpfillnothing)
       ENDIF
       !                            !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
@@ -799,92 +875,147 @@
       SELECT CASE ( nn_amxl )
       !
-      CASE ( 0 )           ! Deardroff 80 length-scale bounded by the distance to surface and bottom         
-#   define zlup zRH      
-#   define zldw zFC 
+      CASE ( 0 )           ! Deardroff 80 length-scale bounded by the distance to surface and bottom
+#   define zlup zRH
+#   define zldw zFC
          DO jj = 1, jpj     ! outer loop
             !
             DO ji = 1, jpi
-               mxl_abl ( ji, jj,    1 )  = 0._wp
-               mxl_abl ( ji, jj, jpka )  = mxl_min
-               zldw( ji,        1 )  = 0._wp              
-               zlup( ji,     jpka )  = 0._wp
-            END DO
-            !
-            DO jk = 2, jpkam1   
-               DO ji = 1, jpi  
-                  zbuoy             = MAX( zbn2(ji, jj, jk), rsmall )  
-                  mxl_abl( ji, jj, jk ) = MAX( mxl_min,  &
-                     &               SQRT( 2._wp * tke_abl( ji, jj, jk, nt_a ) / zbuoy )   ) 
-               END DO
-            END DO   
+               mxld_abl( ji, jj,    1 ) = mxl_min
+               mxld_abl( ji, jj, jpka ) = mxl_min
+               mxlm_abl( ji, jj,    1 ) = mxl_min
+               mxlm_abl( ji, jj, jpka ) = mxl_min
+               zldw    ( ji,        1 ) = zrough(ji,jj) * rn_Lsfc
+               zlup    ( ji,     jpka ) = mxl_min
+            END DO
+            !
+            DO jk = 2, jpkam1
+               DO ji = 1, jpi
+                  zbuoy = MAX( zbn2(ji, jj, jk), rsmall )
+                  mxlm_abl( ji, jj, jk ) = MAX( mxl_min,  &
+                     &               SQRT( 2._wp * tke_abl( ji, jj, jk, nt_a ) / zbuoy ) )
+               END DO
+            END DO
             !
             ! Limit mxl
-            DO jk = jpkam1,1,-1   
-               DO ji = 1, jpi 
-                  zlup(ji,jk) = MIN( zlup(ji,jk+1) + (ghw_abl(jk+1)-ghw_abl(jk)) , mxl_abl(ji, jj, jk) )
-               END DO
-            END DO   
+            DO jk = jpkam1,1,-1
+               DO ji = 1, jpi
+                  zlup(ji,jk) = MIN( zlup(ji,jk+1) + (ghw_abl(jk+1)-ghw_abl(jk)) , mxlm_abl(ji, jj, jk) )
+               END DO
+            END DO
             !
             DO jk = 2, jpka
-               DO ji = 1, jpi  
-                  zldw(ji,jk) = MIN( zldw(ji,jk-1) + (ghw_abl(jk)-ghw_abl(jk-1)) , mxl_abl(ji, jj, jk) )   
-               END DO
-            END DO 
+               DO ji = 1, jpi
+                  zldw(ji,jk) = MIN( zldw(ji,jk-1) + (ghw_abl(jk)-ghw_abl(jk-1)) , mxlm_abl(ji, jj, jk) )
+               END DO
+            END DO
+            !
+!            DO jk = 1, jpka
+!               DO ji = 1, jpi
+!                  mxlm_abl( ji, jj, jk ) = SQRT( zldw( ji, jk ) * zlup( ji, jk ) )
+!                  mxld_abl( ji, jj, jk ) = MIN ( zldw( ji, jk ),  zlup( ji, jk ) )
+!               END DO
+!            END DO
             !
             DO jk = 1, jpka
                DO ji = 1, jpi
-                  mxl_abl( ji, jj, jk ) = SQRT( zldw( ji, jk ) * zlup( ji, jk ) )   
-               END DO
-            END DO                         
-            !
-         END DO
-#   undef zlup      
-#   undef zldw  
-         !
-         !
-      CASE ( 1 )             ! length-scale computed as the distance to the PBL height
-         DO jj = 1,jpj      ! outer loop
-            !
-            DO ji = 1, jpi   ! vector opt.
-               zcff = 1._wp / pblh( ji, jj )     ! inverse of hbl              
-               DO jk = 1, jpka              
-                  zsig  = MIN( zcff * ghw_abl( jk ), 1. )    
-                  zcff1 = pblh( ji, jj )                 
-                  mxl_abl( ji, jj, jk ) =  mxl_min                           &
-                     &  +  zsig         * (  amx1*zcff1 + bmx1*mxl_min ) &
-                     &  +  zsig *  zsig * (  amx2*zcff1 + bmx2*mxl_min ) &
-                     &  +  zsig**3      * (  amx3*zcff1 + bmx3*mxl_min ) &
-                     &  +  zsig**4      * (  amx4*zcff1 + bmx4*mxl_min ) &
-                     &  +  zsig**5      * (  amx5*zcff1 + bmx5*mxl_min )
-               END DO
-            END DO 
-            !            
-         END DO            
+!                  zcff = 2.*SQRT(2.)*(  zldw( ji, jk )**(-2._wp/3._wp) + zlup( ji, jk )**(-2._wp/3._wp)  )**(-3._wp/2._wp)
+                  zcff = SQRT( zldw( ji, jk ) * zlup( ji, jk ) )
+                  mxlm_abl( ji, jj, jk ) = MAX( zcff, mxl_min )
+                  mxld_abl( ji, jj, jk ) = MAX( MIN( zldw( ji, jk ),  zlup( ji, jk ) ), mxl_min )
+               END DO
+            END DO
+            !
+         END DO
+#   undef zlup
+#   undef zldw
+         !
+         !
+      CASE ( 1 )           ! Modified Deardroff 80 length-scale bounded by the distance to surface and bottom
+#   define zlup zRH
+#   define zldw zFC
+         DO jj = 1, jpj     ! outer loop
+            !
+            DO jk = 2, jpkam1
+               DO ji = 1,jpi
+                              zcff        = 1.0_wp / e3w_abl( jk )**2
+                  zdU         = zcff* (u_abl( ji, jj, jk+1, tind)-u_abl( ji, jj, jk  , tind) )**2
+                  zdV         = zcff* (v_abl( ji, jj, jk+1, tind)-v_abl( ji, jj, jk  , tind) )**2
+                  zsh2(ji,jk) = SQRT(zdU+zdV)   !<-- zsh2 = SQRT ( ( du/dz )^2 + ( dv/dz )^2 )
+                           ENDDO
+                        ENDDO
+                        !
+            DO ji = 1, jpi
+               zcff                      = zrough(ji,jj) * rn_Lsfc
+               mxld_abl ( ji, jj,    1 ) = zcff
+               mxld_abl ( ji, jj, jpka ) = mxl_min
+               mxlm_abl ( ji, jj,    1 ) = zcff
+               mxlm_abl ( ji, jj, jpka ) = mxl_min
+               zldw     ( ji,        1 ) = zcff
+               zlup     ( ji,     jpka ) = mxl_min
+            END DO
+            !
+            DO jk = 2, jpkam1
+               DO ji = 1, jpi
+                  zbuoy    = MAX( zbn2(ji, jj, jk), rsmall )
+                  zcff     = 2.*SQRT(tke_abl( ji, jj, jk, nt_a )) / ( rn_Rod*zsh2(ji,jk) &
+                                &             + SQRT( rn_Rod*rn_Rod*zsh2(ji,jk)*zsh2(ji,jk)+2.*zbuoy ) )
+                                  mxlm_abl( ji, jj, jk ) = MAX( mxl_min, zcff )
+               END DO
+            END DO
+            !
+            ! Limit mxl
+            DO jk = jpkam1,1,-1
+               DO ji = 1, jpi
+                  zlup(ji,jk) = MIN( zlup(ji,jk+1) + (ghw_abl(jk+1)-ghw_abl(jk)) , mxlm_abl(ji, jj, jk) )
+               END DO
+            END DO
+            !
+            DO jk = 2, jpka
+               DO ji = 1, jpi
+                  zldw(ji,jk) = MIN( zldw(ji,jk-1) + (ghw_abl(jk)-ghw_abl(jk-1)) , mxlm_abl(ji, jj, jk) )
+               END DO
+            END DO
+            !
+            DO jk = 1, jpka
+               DO ji = 1, jpi
+                  !mxlm_abl( ji, jj, jk ) = SQRT( zldw( ji, jk ) * zlup( ji, jk ) )
+                  !zcff = 2.*SQRT(2.)*(  zldw( ji, jk )**(-2._wp/3._wp) + zlup( ji, jk )**(-2._wp/3._wp)  )**(-3._wp/2._wp)
+                  zcff = SQRT( zldw( ji, jk ) * zlup( ji, jk ) )
+                  mxlm_abl( ji, jj, jk ) = MAX( zcff, mxl_min )
+                  !mxld_abl( ji, jj, jk ) = MIN( zldw( ji, jk ), zlup( ji, jk ) )
+                  mxld_abl( ji, jj, jk ) = MAX( MIN( zldw( ji, jk ),  zlup( ji, jk ) ), mxl_min )
+               END DO
+            END DO
+ !
+         END DO
+#   undef zlup
+#   undef zldw
          !
       CASE ( 2 )           ! Bougeault & Lacarrere 89 length-scale
          !
-#   define zlup zRH      
-#   define zldw zFC           
+#   define zlup zRH
+#   define zldw zFC
 ! zCF is used for matrix inversion
-!             
+!
        DO jj = 1, jpj      ! outer loop
-         
-         DO ji = 1, jpi           
-            zlup( ji,    1 ) = mxl_min
-            zldw( ji,    1 ) = mxl_min               
+
+         DO ji = 1, jpi
+            zcff             = zrough(ji,jj) * rn_Lsfc
+            zlup( ji,    1 ) = zcff
+            zldw( ji,    1 ) = zcff
             zlup( ji, jpka ) = mxl_min
-            zldw( ji, jpka ) = mxl_min                
-         END DO            
-         
+            zldw( ji, jpka ) = mxl_min
+         END DO
+
          DO jk = 2,jpka-1
             DO ji = 1, jpi
                zlup(ji,jk) = ghw_abl(jpka) - ghw_abl(jk)
-               zldw(ji,jk) = ghw_abl(jk  ) - ghw_abl( 1)        
-            END DO
-         END DO         
+               zldw(ji,jk) = ghw_abl(jk  ) - ghw_abl( 1)
+            END DO
+         END DO
          !!
          !! BL89 search for lup
-         !! ----------------------------------------------------------           
-         DO jk=2,jpka-1 
+         !! ----------------------------------------------------------
+         DO jk=2,jpka-1
             !
             DO ji = 1, jpi
@@ -892,17 +1023,20 @@
                zCF(ji,  jk  ) = - tke_abl( ji, jj, jk, nt_a )
                ln_foundl(ji ) = .false.
-            END DO   
-            !           
+            END DO
+            !
             DO jkup=jk+1,jpka-1
                DO ji = 1, jpi
+                  zbuoy1 = MAX( zbn2(ji,jj,jkup  ), rsmall )
+                  zbuoy2 = MAX( zbn2(ji,jj,jkup-1), rsmall )
                   zCF (ji,jkup) = zCF (ji,jkup-1) + 0.5_wp * e3t_abl(jkup) * &
-                     &               ( zbn2(ji,jj,jkup  )*(ghw_abl(jkup  )-ghw_abl(jk)) &
-                     &               + zbn2(ji,jj,jkup-1)*(ghw_abl(jkup-1)-ghw_abl(jk)) )
+                     &               ( zbuoy1*(ghw_abl(jkup  )-ghw_abl(jk)) &
+                     &               + zbuoy2*(ghw_abl(jkup-1)-ghw_abl(jk)) )
                   IF( zCF (ji,jkup) * zCF (ji,jkup-1) .le. 0._wp .and. .not. ln_foundl(ji) ) THEN
                      zcff2 = ghw_abl(jkup  ) - ghw_abl(jk)
-                     zcff1 = ghw_abl(jkup-1) - ghw_abl(jk)                   
+                     zcff1 = ghw_abl(jkup-1) - ghw_abl(jk)
                      zcff  = ( zcff1 * zCF(ji,jkup) - zcff2 * zCF(ji,jkup-1) ) /   &
-                        &    (         zCF(ji,jkup) -         zCF(ji,jkup-1) ) 
-                     zlup(ji,jk) = zcff                
+                        &    (         zCF(ji,jkup) -         zCF(ji,jkup-1) )
+                     zlup(ji,jk) = zcff
+                     zlup(ji,jk) = ghw_abl(jkup  ) - ghw_abl(jk)
                      ln_foundl(ji) = .true.
                   END IF
@@ -910,9 +1044,9 @@
             END DO
             !
-         END DO   
+         END DO
          !!
          !! BL89 search for ldwn
-         !! ----------------------------------------------------------          
-         DO jk=2,jpka-1         
+         !! ----------------------------------------------------------
+         DO jk=2,jpka-1
             !
             DO ji = 1, jpi
@@ -920,55 +1054,179 @@
                zCF(ji,  jk  ) = - tke_abl( ji, jj, jk, nt_a )
                ln_foundl(ji ) = .false.
-            END DO  
-            !   
+            END DO
+            !
             DO jkdwn=jk-1,1,-1
-               DO ji = 1, jpi             
+               DO ji = 1, jpi
+                  zbuoy1 = MAX( zbn2(ji,jj,jkdwn+1), rsmall )
+                  zbuoy2 = MAX( zbn2(ji,jj,jkdwn  ), rsmall )
                   zCF (ji,jkdwn) = zCF (ji,jkdwn+1) + 0.5_wp * e3t_abl(jkdwn+1)  &
-                     &               * ( zbn2(ji,jj,jkdwn+1)*(ghw_abl(jk)-ghw_abl(jkdwn+1)) &
-                                       + zbn2(ji,jj,jkdwn  )*(ghw_abl(jk)-ghw_abl(jkdwn  )) )   
-                  IF(zCF (ji,jkdwn) * zCF (ji,jkdwn+1) .le. 0._wp  .and. .not. ln_foundl(ji) ) THEN 
+                     &               * ( zbuoy1*(ghw_abl(jk)-ghw_abl(jkdwn+1)) &
+                                       + zbuoy2*(ghw_abl(jk)-ghw_abl(jkdwn  )) )
+                  IF(zCF (ji,jkdwn) * zCF (ji,jkdwn+1) .le. 0._wp  .and. .not. ln_foundl(ji) ) THEN
                      zcff2 = ghw_abl(jk) - ghw_abl(jkdwn+1)
-                     zcff1 = ghw_abl(jk) - ghw_abl(jkdwn  )              
+                     zcff1 = ghw_abl(jk) - ghw_abl(jkdwn  )
                      zcff  = ( zcff1 * zCF(ji,jkdwn+1) - zcff2 * zCF(ji,jkdwn) ) /   &
-                        &    (         zCF(ji,jkdwn+1) -         zCF(ji,jkdwn) ) 
-                     zldw(ji,jk) = zcff 
-                     ln_foundl(ji) = .true.               
-                  END IF                                   
-               END DO
-            END DO
-            !      
+                        &    (         zCF(ji,jkdwn+1) -         zCF(ji,jkdwn) )
+                     zldw(ji,jk) = zcff
+                     zldw(ji,jk) = ghw_abl(jk) - ghw_abl(jkdwn  )
+                     ln_foundl(ji) = .true.
+                  END IF
+               END DO
+            END DO
+            !
          END DO
 
          DO jk = 1, jpka
-            DO ji = 1, jpi  
-               mxl_abl( ji, jj, jk ) = MAX( SQRT( zldw( ji, jk ) * zlup( ji, jk ) ), mxl_min )  
-            END DO
-         END DO  
+            DO ji = 1, jpi
+               !zcff = 2.*SQRT(2.)*(  zldw( ji, jk )**(-2._wp/3._wp) + zlup( ji, jk )**(-2._wp/3._wp)  )**(-3._wp/2._wp)
+               zcff = SQRT( zldw( ji, jk ) * zlup( ji, jk ) )
+               mxlm_abl( ji, jj, jk ) = MAX( zcff, mxl_min )
+               mxld_abl( ji, jj, jk ) = MAX( MIN( zldw( ji, jk ),  zlup( ji, jk ) ), mxl_min )
+            END DO
+         END DO
 
       END DO
-#   undef zlup      
-#   undef zldw           
-         !
-      END SELECT      
+#   undef zlup
+#   undef zldw
+         !
+     CASE ( 3 )           ! Bougeault & Lacarrere 89 length-scale
+         !
+#   define zlup zRH
+#   define zldw zFC
+! zCF is used for matrix inversion
+!
+       DO jj = 1, jpj      ! outer loop
+          !
+          DO jk = 2, jpkam1
+             DO ji = 1,jpi
+                            zcff        = 1.0_wp / e3w_abl( jk )**2
+                zdU         = zcff* (u_abl( ji, jj, jk+1, tind)-u_abl( ji, jj, jk  , tind) )**2
+                zdV         = zcff* (v_abl( ji, jj, jk+1, tind)-v_abl( ji, jj, jk  , tind) )**2
+                zsh2(ji,jk) = SQRT(zdU+zdV)   !<-- zsh2 = SQRT ( ( du/dz )^2 + ( dv/dz )^2 )
+                         ENDDO
+                  ENDDO
+          zsh2(:,      1) = zsh2( :,      2)
+          zsh2(:,   jpka) = zsh2( :, jpkam1)
+
+                 DO ji = 1, jpi
+            zcff              = zrough(ji,jj) * rn_Lsfc
+                        zlup( ji,    1 )  = zcff
+            zldw( ji,    1 )  = zcff
+            zlup( ji, jpka ) = mxl_min
+            zldw( ji, jpka ) = mxl_min
+         END DO
+
+         DO jk = 2,jpka-1
+            DO ji = 1, jpi
+               zlup(ji,jk) = ghw_abl(jpka) - ghw_abl(jk)
+               zldw(ji,jk) = ghw_abl(jk  ) - ghw_abl( 1)
+            END DO
+         END DO
+         !!
+         !! BL89 search for lup
+         !! ----------------------------------------------------------
+         DO jk=2,jpka-1
+            !
+            DO ji = 1, jpi
+               zCF(ji,1:jpka) = 0._wp
+               zCF(ji,  jk  ) = - tke_abl( ji, jj, jk, nt_a )
+               ln_foundl(ji ) = .false.
+            END DO
+            !
+            DO jkup=jk+1,jpka-1
+               DO ji = 1, jpi
+                  zbuoy1             = MAX( zbn2(ji,jj,jkup  ), rsmall )
+                  zbuoy2             = MAX( zbn2(ji,jj,jkup-1), rsmall )
+                  zCF (ji,jkup) = zCF (ji,jkup-1) + 0.5_wp * e3t_abl(jkup) *                 &
+                     &               ( zbuoy1*(ghw_abl(jkup  )-ghw_abl(jk))      &
+                     &               + zbuoy2*(ghw_abl(jkup-1)-ghw_abl(jk)) )    &
+                                         &                            + 0.5_wp * e3t_abl(jkup) * rn_Rod *        &
+                                         &               ( SQRT(tke_abl( ji, jj, jkup  , nt_a ))*zsh2(ji,jkup  ) &
+                                         &               + SQRT(tke_abl( ji, jj, jkup-1, nt_a ))*zsh2(ji,jkup-1) )
+
+                  IF( zCF (ji,jkup) * zCF (ji,jkup-1) .le. 0._wp .and. .not. ln_foundl(ji) ) THEN
+                     zcff2 = ghw_abl(jkup  ) - ghw_abl(jk)
+                     zcff1 = ghw_abl(jkup-1) - ghw_abl(jk)
+                     zcff  = ( zcff1 * zCF(ji,jkup) - zcff2 * zCF(ji,jkup-1) ) /   &
+                        &    (         zCF(ji,jkup) -         zCF(ji,jkup-1) )
+                     zlup(ji,jk) = zcff
+                     zlup(ji,jk) = ghw_abl(jkup  ) - ghw_abl(jk)
+                     ln_foundl(ji) = .true.
+                  END IF
+               END DO
+            END DO
+            !
+         END DO
+         !!
+         !! BL89 search for ldwn
+         !! ----------------------------------------------------------
+         DO jk=2,jpka-1
+            !
+            DO ji = 1, jpi
+               zCF(ji,1:jpka) = 0._wp
+               zCF(ji,  jk  ) = - tke_abl( ji, jj, jk, nt_a )
+               ln_foundl(ji ) = .false.
+            END DO
+            !
+            DO jkdwn=jk-1,1,-1
+               DO ji = 1, jpi
+                  zbuoy1             = MAX( zbn2(ji,jj,jkdwn+1), rsmall )
+                  zbuoy2             = MAX( zbn2(ji,jj,jkdwn  ), rsmall )
+                  zCF (ji,jkdwn) = zCF (ji,jkdwn+1) + 0.5_wp * e3t_abl(jkdwn+1)  &
+                     &               * (zbuoy1*(ghw_abl(jk)-ghw_abl(jkdwn+1))    &
+                     &                 +zbuoy2*(ghw_abl(jk)-ghw_abl(jkdwn  )) )  &
+                                         &                            + 0.5_wp * e3t_abl(jkup) * rn_Rod *          &
+                                         &               ( SQRT(tke_abl( ji, jj, jkdwn+1, nt_a ))*zsh2(ji,jkdwn+1) &
+                                         &               + SQRT(tke_abl( ji, jj, jkdwn  , nt_a ))*zsh2(ji,jkdwn  ) )
+
+                  IF(zCF (ji,jkdwn) * zCF (ji,jkdwn+1) .le. 0._wp  .and. .not. ln_foundl(ji) ) THEN
+                     zcff2 = ghw_abl(jk) - ghw_abl(jkdwn+1)
+                     zcff1 = ghw_abl(jk) - ghw_abl(jkdwn  )
+                     zcff  = ( zcff1 * zCF(ji,jkdwn+1) - zcff2 * zCF(ji,jkdwn) ) /   &
+                        &    (         zCF(ji,jkdwn+1) -         zCF(ji,jkdwn) )
+                     zldw(ji,jk) = zcff
+                     zldw(ji,jk) = ghw_abl(jk) - ghw_abl(jkdwn  )
+                     ln_foundl(ji) = .true.
+                  END IF
+               END DO
+            END DO
+            !
+         END DO
+
+         DO jk = 1, jpka
+            DO ji = 1, jpi
+               !zcff = 2.*SQRT(2.)*(  zldw( ji, jk )**(-2._wp/3._wp) + zlup( ji, jk )**(-2._wp/3._wp)  )**(-3._wp/2._wp)
+               zcff = SQRT( zldw( ji, jk ) * zlup( ji, jk ) )
+               mxlm_abl( ji, jj, jk ) = MAX( zcff, mxl_min )
+               mxld_abl( ji, jj, jk ) = MAX(  MIN( zldw( ji, jk ),  zlup( ji, jk ) ), mxl_min )
+            END DO
+         END DO
+
+      END DO
+#   undef zlup
+#   undef zldw
+         !
+         !
+      END SELECT
       !                            !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
       !                            !  Finalize the computation of turbulent visc./diff.
       !                            !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
-      
+
       !-------------
       DO jj = 1, jpj     ! outer loop
       !-------------
-         DO jk = 1, jpka   
+         DO jk = 1, jpka
             DO ji = 1, jpi  ! vector opt.
-               zcff              = MAX( rn_phimax, rn_Ric * mxl_abl( ji, jj, jk ) * mxl_abl( ji, jj, jk )  &
-                  &                                       * zbn2(ji, jj, jk) / tke_abl( ji, jj, jk, nt_a ) ) 
-               zcff2             =  1. / ( 1. + zcff )   !<-- phi_z(z)
-               zcff              = mxl_abl( ji, jj, jk ) * SQRT( tke_abl( ji, jj, jk, nt_a ) )
-!!FL: MAX function probably useless because of the definition of mxl_min             
+               zcff  = MAX( rn_phimax, rn_Ric * mxlm_abl( ji, jj, jk ) * mxld_abl( ji, jj, jk )  &
+               &     * MAX( zbn2(ji, jj, jk), rsmall ) / tke_abl( ji, jj, jk, nt_a ) )
+               zcff2 =  1. / ( 1. + zcff )   !<-- phi_z(z)
+               zcff  = mxlm_abl( ji, jj, jk ) * SQRT( tke_abl( ji, jj, jk, nt_a ) )
+               !!FL: MAX function probably useless because of the definition of mxl_min
                Avm_abl( ji, jj, jk ) = MAX( rn_Cm * zcff         , avm_bak   )
-               Avt_abl( ji, jj, jk ) = MAX( rn_Ct * zcff * zcff2 , avt_bak   )                              
-            END DO
-         END DO
-      !-------------         
-      END DO      
+               Avt_abl( ji, jj, jk ) = MAX( rn_Ct * zcff * zcff2 , avt_bak   )
+            END DO
+         END DO
+      !-------------
+      END DO
       !-------------
 
@@ -988,10 +1246,10 @@
       !!
       !! ---------------------------------------------------------------------
-	  REAL(wp), DIMENSION(jpi,jpj), INTENT(in   ) :: msk   
-	  REAL(wp), DIMENSION(jpi,jpj), INTENT(inout) :: pvar2d
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(in   ) :: msk
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(inout) :: pvar2d
       INTEGER                                     :: ji,jj
-	  REAL(wp)                                    :: smth_a, smth_b
-	  REAL(wp), DIMENSION(jpi,jpj)                :: zdX,zdY,zFX,zFY
-	  REAL(wp)                                    :: zumsk,zvmsk
+      REAL(wp)                                    :: smth_a, smth_b
+      REAL(wp), DIMENSION(jpi,jpj)                :: zdX,zdY,zFX,zFY
+      REAL(wp)                                    :: zumsk,zvmsk
       !!
       !!=========================================================
@@ -1005,15 +1263,15 @@
          zdX ( ji, jj ) = ( pvar2d( ji+1,jj ) - pvar2d( ji  ,jj ) ) * zumsk
       END_2D
-      
-	  DO_2D_10_11
+
+      DO_2D_10_11
          zvmsk = msk(ji,jj) * msk(ji,jj+1)
          zdY ( ji, jj ) = ( pvar2d( ji, jj+1 ) - pvar2d( ji  ,jj ) ) * zvmsk
-	  END_2D
-      
-	  DO_2D_10_00
+      END_2D
+
+      DO_2D_10_00
          zFY ( ji, jj  ) =   zdY ( ji, jj   )                        &
             & +  smth_a*  ( (zdX ( ji, jj+1 ) - zdX( ji-1, jj+1 ))   &
             &            -  (zdX ( ji, jj   ) - zdX( ji-1, jj   ))  )
-	  END_2D
+      END_2D
 
       DO_2D_00_10
@@ -1029,5 +1287,5 @@
   &                 +zFY( ji, jj ) - zFY( ji, jj-1 )  )
       END_2D
-	  !!
+
 !---------------------------------------------------------------------------------------------------
    END SUBROUTINE smooth_pblh
Index: NEMO/branches/2020/dev_r12558_HPC-08_epico_Extra_Halo/src/ABL/ablrst.F90
===================================================================
--- NEMO/branches/2020/dev_r12558_HPC-08_epico_Extra_Halo/src/ABL/ablrst.F90	(revision 13228)
+++ NEMO/branches/2020/dev_r12558_HPC-08_epico_Extra_Halo/src/ABL/ablrst.F90	(revision 13229)
@@ -109,5 +109,5 @@
       CALL iom_delay_rst( 'WRITE', 'ABL', numraw )   ! save only abl delayed global communication variables
 
-      ! Prognostic variables
+      ! Prognostic (after timestep + swap time indices = now timestep) variables
       CALL iom_rstput( iter, nitrst, numraw,   'u_abl',   u_abl(:,:,:,nt_n      ) )
       CALL iom_rstput( iter, nitrst, numraw,   'v_abl',   v_abl(:,:,:,nt_n      ) )
@@ -117,5 +117,5 @@
       CALL iom_rstput( iter, nitrst, numraw, 'avm_abl', avm_abl(:,:,:           ) )
       CALL iom_rstput( iter, nitrst, numraw, 'avt_abl', avt_abl(:,:,:           ) )
-      CALL iom_rstput( iter, nitrst, numraw, 'mxl_abl', mxl_abl(:,:,:           ) )
+      CALL iom_rstput( iter, nitrst, numraw,'mxld_abl',mxld_abl(:,:,:           ) )
       CALL iom_rstput( iter, nitrst, numraw,    'pblh',    pblh(:,:             ) )
       !
@@ -172,5 +172,5 @@
       CALL iom_get( numrar, jpdom_auto, 'avm_abl', avm_abl(:,:,:           ) )
       CALL iom_get( numrar, jpdom_auto, 'avt_abl', avt_abl(:,:,:           ) )
-      CALL iom_get( numrar, jpdom_auto, 'mxl_abl', mxl_abl(:,:,:           ) )
+      CALL iom_get( numrar, jpdom_auto,'mxld_abl',mxld_abl(:,:,:           ) )
       CALL iom_get( numrar, jpdom_auto,    'pblh',    pblh(:,:             ) )
       CALL iom_delay_rst( 'READ', 'ABL', numrar )   ! read only abl delayed global communication variables
Index: NEMO/branches/2020/dev_r12558_HPC-08_epico_Extra_Halo/src/ABL/par_abl.F90
===================================================================
--- NEMO/branches/2020/dev_r12558_HPC-08_epico_Extra_Halo/src/ABL/par_abl.F90	(revision 13228)
+++ NEMO/branches/2020/dev_r12558_HPC-08_epico_Extra_Halo/src/ABL/par_abl.F90	(revision 13229)
@@ -28,10 +28,11 @@
    LOGICAL , PUBLIC            ::   ln_hpgls_frc   !: forcing of ABL winds by large-scale pressure gradient 
    LOGICAL , PUBLIC            ::   ln_smth_pblh   !: smoothing of atmospheric PBL height 
+   !LOGICAL , PUBLIC            ::   ln_topbc_neumann = .FALSE.  !: idealised testcases only
 
-   LOGICAL           , PUBLIC ::   ln_rstart_abl    !: (de)activate abl restart
-   CHARACTER(len=256), PUBLIC ::   cn_ablrst_in     !: suffix of abl restart name (input)
-   CHARACTER(len=256), PUBLIC ::   cn_ablrst_out    !: suffix of abl restart name (output)
-   CHARACTER(len=256), PUBLIC ::   cn_ablrst_indir  !: abl restart input directory
-   CHARACTER(len=256), PUBLIC ::   cn_ablrst_outdir !: abl restart output directory
+   LOGICAL           , PUBLIC  ::   ln_rstart_abl    !: (de)activate abl restart
+   CHARACTER(len=256), PUBLIC  ::   cn_ablrst_in     !: suffix of abl restart name (input)
+   CHARACTER(len=256), PUBLIC  ::   cn_ablrst_out    !: suffix of abl restart name (output)
+   CHARACTER(len=256), PUBLIC  ::   cn_ablrst_indir  !: abl restart input directory
+   CHARACTER(len=256), PUBLIC  ::   cn_ablrst_outdir !: abl restart output directory
 
    !!---------------------------------------------------------------------
@@ -46,10 +47,12 @@
    REAL(wp), PUBLIC, PARAMETER ::   rn_Cek    = 258._wp                   !: Ekman constant for Richardson number 
    REAL(wp), PUBLIC, PARAMETER ::   rn_epssfc = 1._wp / ( 1._wp + 2.8_wp * 2.8_wp )
-   REAL(wp), PUBLIC            ::   rn_ceps                       !: namelist parameter
-   REAL(wp), PUBLIC            ::   rn_cm                         !: namelist parameter
-   REAL(wp), PUBLIC            ::   rn_ct                         !: namelist parameter
-   REAL(wp), PUBLIC            ::   rn_ce                         !: namelist parameter 
+   REAL(wp), PUBLIC            ::   rn_Ceps                       !: namelist parameter
+   REAL(wp), PUBLIC            ::   rn_Cm                         !: namelist parameter
+   REAL(wp), PUBLIC            ::   rn_Ct                         !: namelist parameter
+   REAL(wp), PUBLIC            ::   rn_Ce                         !: namelist parameter 
    REAL(wp), PUBLIC            ::   rn_Rod                        !: namelist parameter   
    REAL(wp), PUBLIC            ::   rn_Sch    
+   REAL(wp), PUBLIC            ::   rn_Esfc
+   REAL(wp), PUBLIC            ::   rn_Lsfc
    REAL(wp), PUBLIC            ::   mxl_min    
    REAL(wp), PUBLIC            ::   rn_ldyn_min                   !: namelist parameter
